"use strict";

var _react = require("@testing-library/react");
var _react2 = _interopRequireDefault(require("react"));
var _switchField = require("../switch-field.js");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
describe('<Switch />', () => {
  it('should call the onKeyDown callback when provided', () => {
    const onKeyDown = jest.fn();
    (0, _react.render)(/*#__PURE__*/_react2.default.createElement(_switchField.SwitchField, {
      label: "label",
      name: "foo",
      value: "bar",
      checked: false,
      onKeyDown: onKeyDown
    }));
    _react.fireEvent.keyDown(_react.screen.getByRole('switch'), {
      key: 'Enter',
      code: 'Enter',
      charCode: 13
    });
    expect(onKeyDown).toHaveBeenCalledWith({
      name: 'foo',
      value: 'bar',
      checked: true
    }, expect.objectContaining({}));
    expect(onKeyDown).toHaveBeenCalledTimes(1);
  });
});