"use strict";

var _react = require("@testing-library/react");
var _react2 = _interopRequireDefault(require("react"));
var _switch = require("../switch.js");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
describe('<Switch />', () => {
  it('should call the onKeyDown callback when provided', () => {
    const onKeyDown = jest.fn();
    (0, _react.render)(/*#__PURE__*/_react2.default.createElement(_switch.Switch, {
      name: "foo",
      value: "bar",
      checked: false,
      onKeyDown: onKeyDown
    }));
    _react.fireEvent.keyDown(_react.screen.getByRole('switch'), {
      key: 'Enter',
      code: 'Enter',
      charCode: 13
    });
    expect(onKeyDown).toHaveBeenCalledWith({
      name: 'foo',
      value: 'bar',
      checked: true
    }, expect.objectContaining({}));
    expect(onKeyDown).toHaveBeenCalledTimes(1);
  });
  it('renders the switch with aria label', () => {
    const ariaLabel = 'test switch';
    (0, _react.render)(/*#__PURE__*/_react2.default.createElement(_switch.Switch, {
      "aria-label": ariaLabel,
      name: "foo",
      value: "bar",
      checked: false
    }));
    expect(_react.screen.getAllByLabelText(ariaLabel)).toHaveLength(1);
  });
});