import { render, fireEvent, screen } from '@testing-library/react';
import React from 'react';
import { SwitchField } from '../switch-field.js';
describe('<Switch />', () => {
  it('should call the onKeyDown callback when provided', () => {
    const onKeyDown = jest.fn();
    render(/*#__PURE__*/React.createElement(SwitchField, {
      label: "label",
      name: "foo",
      value: "bar",
      checked: false,
      onKeyDown: onKeyDown
    }));
    fireEvent.keyDown(screen.getByRole('switch'), {
      key: 'Enter',
      code: 'Enter',
      charCode: 13
    });
    expect(onKeyDown).toHaveBeenCalledWith({
      name: 'foo',
      value: 'bar',
      checked: true
    }, expect.objectContaining({}));
    expect(onKeyDown).toHaveBeenCalledTimes(1);
  });
});